# IRpView3D Interface Reference

Inherits IRsObject, and IRsObject.

List of all members.

## Public Member Functions
HRESULT | CreateViewHelper ([out, retval] IRsViewHelper **spHelper)
HRESULT | Render3DObject ([in] IRsNode *pObjectRoot,[in] RtBool bUseAsSingleObject,[in] IRsNode *pCameraNode,[in] RtBool bUseOnlyCameraDirection,[in] IRsNode *pLightRoot,[in] RtBool bUseLightAsSingleObject,[in] RtDWORD dwWidth,[in] RtDWORD dwHeight,[in] RtBool bSuperSample,[in] COLORREF dwBackgroundColor,[out, retval] IRdBitmap **pImage)
HRESULT | IsRenderableObject ([in] IRsBaseNode *pObject)
HRESULT | IsLight ([in] IRsBaseNode *pObject)
HRESULT | IsCamera ([in] IRsBaseNode *pObject)
HRESULT | GetRenderAttributesOverrideManager ([out, retval] IRsRenderAttributesOverride **spHelper)
HRESULT | CreateViewHelper ([out, retval] IRsViewHelper **spHelper)
HRESULT | Render3DObject ([in] IRsNode *pObjectRoot,[in] RtBool bUseAsSingleObject,[in] IRsNode *pCameraNode,[in] RtBool bUseOnlyCameraDirection,[in] IRsNode *pLightRoot,[in] RtBool bUseLightAsSingleObject,[in] RtDWORD dwWidth,[in] RtDWORD dwHeight,[in] RtBool bSuperSample,[in] COLORREF dwBackgroundColor,[out, retval] IRdBitmap **pImage)
HRESULT | IsRenderableObject ([in] IRsBaseNode *pObject)
HRESULT | IsLight ([in] IRsBaseNode *pObject)
HRESULT | IsCamera ([in] IRsBaseNode *pObject)
HRESULT | GetRenderAttributesOverrideManager ([out, retval] IRsRenderAttributesOverride **spHelper)

## Detailed Description

View3d package.

## Member Function Documentation

HRESULT IRpView3D::CreateViewHelper | ( | [out, retval] IRsViewHelper ** | spHelper | ) |

CreateViewHelper

Returns:
  spHelper [out,retval] interface to created view helper object .

HRESULT IRpView3D::Render3DObject | ( | [in] IRsNode * | pObjectRoot,
|  | [in] RtBool | bUseAsSingleObject,
|  | [in] IRsNode * | pCameraNode,
|  | [in] RtBool | bUseOnlyCameraDirection,
|  | [in] IRsNode * | pLightRoot,
|  | [in] RtBool | bUseLightAsSingleObject,
|  | [in] RtDWORD | dwWidth,
|  | [in] RtDWORD | dwHeight,
|  | [in] RtBool | bSuperSample,
|  | [in] COLORREF | dwBackgroundColor,
|  | [out, retval] IRdBitmap ** | pImage |
| ) |  |  |

This method performs extensive graph scanning and node creation and therefore can be called only from interface or master thread commands!!!

Parameters:

  | pObjectRoot | [in] Is the object or root of objects to render.
  | bUseAsSingleObject | [in] Specifies whether pObjectRoot is single object or a root to a sub-scene (to render all objects inside pObjectRoot).
  | pCameraNode | [in] If pCameraNode is NULL (or node that cannot be found), default camera will be used.
  | bUseOnlyCameraDirection | [in] Parameter bUseOnlyCameraDirection will cause default camera fit to be used, but the direction would be taken from pCameraNode.
  | pLightRoot | [in] If pLightRoot is not NULL lighting information will be taken from that place. If it's NULL default lighting information would be used.
  | bUseLightAsSingleObject | [in] lighting setup.
  | dwWidth | [in] width of output bitmap.
  | dwHeight | [in] height of output bitmap.
  | bSuperSample | [in] supersamplig.
  | dwBackgroundColor | [in] backgorund color .

Returns:
  pImage [out, retval] output rendered image.

HRESULT IRpView3D::IsRenderableObject | ( | [in] IRsBaseNode * | pObject | ) |

Discover if given node is currently registered as 3D object inside View3D.

Parameters:

  | pObject | [in] Specifies object to check.

Returns:
  S_OK if object is in View3D.

  E_INVALIDARG if object is not found in View3D.

HRESULT IRpView3D::IsLight | ( | [in] IRsBaseNode * | pObject | ) |

Discover if given node is currently registered as light inside View3D.

Parameters:

  | pObject | [in] Specifies object to check.

Returns:
  S_OK if object is in View3D.

  E_INVALIDARG if object is not found in View3D.

HRESULT IRpView3D::IsCamera | ( | [in] IRsBaseNode * | pObject | ) |

Discover if given node is currently registered as camera inside View3D.

Parameters:

  | pObject | [in] Specifies object to check.

Returns:
  S_OK if object is in View3D.

  E_INVALIDARG if object is not found in View3D.

HRESULT IRpView3D::GetRenderAttributesOverrideManager | ( | [out, retval] IRsRenderAttributesOverride ** | spHelper | ) |

GetRenderAttributesOverrideManager

Returns:
  spHelper [out,retval] interface to render attributes override manager .

HRESULT IRpView3D::CreateViewHelper | ( | [out, retval] IRsViewHelper ** | spHelper | ) |

CreateViewHelper

Returns:
  spHelper [out,retval] interface to created view helper object .

HRESULT IRpView3D::Render3DObject | ( | [in] IRsNode * | pObjectRoot,
|  | [in] RtBool | bUseAsSingleObject,
|  | [in] IRsNode * | pCameraNode,
|  | [in] RtBool | bUseOnlyCameraDirection,
|  | [in] IRsNode * | pLightRoot,
|  | [in] RtBool | bUseLightAsSingleObject,
|  | [in] RtDWORD | dwWidth,
|  | [in] RtDWORD | dwHeight,
|  | [in] RtBool | bSuperSample,
|  | [in] COLORREF | dwBackgroundColor,
|  | [out, retval] IRdBitmap ** | pImage |
| ) |  |  |

This method performs extensive graph scanning and node creation and therefore can be called only from interface or master thread commands!!!

Parameters:

  | pObjectRoot | [in] Is the object or root of objects to render.
  | bUseAsSingleObject | [in] Specifies whether pObjectRoot is single object or a root to a sub-scene (to render all objects inside pObjectRoot).
  | pCameraNode | [in] If pCameraNode is NULL (or node that cannot be found), default camera will be used.
  | bUseOnlyCameraDirection | [in] Parameter bUseOnlyCameraDirection will cause default camera fit to be used, but the direction would be taken from pCameraNode.
  | pLightRoot | [in] If pLightRoot is not NULL lighting information will be taken from that place. If it's NULL default lighting information would be used.
  | bUseLightAsSingleObject | [in] lighting setup.
  | dwWidth | [in] width of output bitmap.
  | dwHeight | [in] height of output bitmap.
  | bSuperSample | [in] supersamplig.
  | dwBackgroundColor | [in] backgorund color .

Returns:
  pImage [out, retval] output rendered image.

HRESULT IRpView3D::IsRenderableObject | ( | [in] IRsBaseNode * | pObject | ) |

Discover if given node is currently registered as 3D object inside View3D.

Parameters:

  | pObject | [in] Specifies object to check.

Returns:
  S_OK if object is in View3D.

  E_INVALIDARG if object is not found in View3D.

HRESULT IRpView3D::IsLight | ( | [in] IRsBaseNode * | pObject | ) |

Discover if given node is currently registered as light inside View3D.

Parameters:

  | pObject | [in] Specifies object to check.

Returns:
  S_OK if object is in View3D.

  E_INVALIDARG if object is not found in View3D.

HRESULT IRpView3D::IsCamera | ( | [in] IRsBaseNode * | pObject | ) |

Discover if given node is currently registered as camera inside View3D.

Parameters:

  | pObject | [in] Specifies object to check.

Returns:
  S_OK if object is in View3D.

  E_INVALIDARG if object is not found in View3D.

HRESULT IRpView3D::GetRenderAttributesOverrideManager | ( | [out, retval] IRsRenderAttributesOverride ** | spHelper | ) |

GetRenderAttributesOverrideManager

Returns:
  spHelper [out,retval] interface to render attributes override manager .